import { Injectable } from "@angular/core";
import { HttpClient, HttpHeaders  } from "@angular/common/http";
import { Observable } from "rxjs";

@Injectable({
  providedIn: "root",
})
export class EnergyMonitoringService {
  constructor(private http: HttpClient) {}

  getListRoomData(): Observable<any> {
    const url = `https://kapi.absys.ninja/hemat/room/list`;
    const headers = new HttpHeaders({
      'Content-Type': 'application/json',
      'x-api-key': 'j2yaYvPSQcsEEmHh3NEobfiXyyXmmnHT'
    });
    return this.http.get<any>(url, { headers });
  }

  getDashboardTopCard(building_id, floor_id, room_id): Observable<any> {
    const url = `https://kapi.absys.ninja/hemat/dashboard/top-card?building_id=${building_id}&floor_id=${floor_id}&room_id=${room_id}`;
    const headers = new HttpHeaders({
      'Content-Type': 'application/json',
      'x-api-key': 'j2yaYvPSQcsEEmHh3NEobfiXyyXmmnHT'
    });
    return this.http.get<any>(url, { headers });
  }

  getDashboardSummary(building_id, floor_id, room_id): Observable<any> {
    const url = `https://kapi.absys.ninja/hemat/dashboard/summary-cost?building_id=${building_id}&floor_id=${floor_id}&room_id=${room_id}`;
    const headers = new HttpHeaders({
      'Content-Type': 'application/json',
      'x-api-key': 'j2yaYvPSQcsEEmHh3NEobfiXyyXmmnHT'
    });
    return this.http.get<any>(url, { headers });
  }

  // getDashboardTemperature(id): Observable<any> {
  //   const url = `https://kapi.absys.ninja/hemat/dashboard/temperature-humidity?building_id=${id}`;
  //   const headers = new HttpHeaders({
  //     'Content-Type': 'application/json',
  //     'x-api-key': 'j2yaYvPSQcsEEmHh3NEobfiXyyXmmnHT'
  //   });
  //   return this.http.get<any>(url, { headers });
  // }

  getDashboardDeviceCategory(building_id, floor_id, room_id): Observable<any> {
    const url = `https://kapi.absys.ninja/hemat/dashboard/device-category-use?building_id=${building_id}&floor_id=${floor_id}&room_id=${room_id}`;
    const headers = new HttpHeaders({
      'Content-Type': 'application/json',
      'x-api-key': 'j2yaYvPSQcsEEmHh3NEobfiXyyXmmnHT'
    });
    return this.http.get<any>(url, { headers });
  }
  getDashboardChartKwhWater(building_id, floor_id, room_id): Observable<any> {
    const url = `https://kapi.absys.ninja/hemat/dashboard/chartKwhWater?building_id=${building_id}&floor_id=${floor_id}&room_id=${room_id}`;
    const headers = new HttpHeaders({
      'Content-Type': 'application/json',
      'x-api-key': 'j2yaYvPSQcsEEmHh3NEobfiXyyXmmnHT'
    });
    return this.http.get<any>(url, { headers });
  }

  getDeviceStatus(id): Observable<any> {
    const endpoint = `devices`;
    const url = `https://kapi.absys.ninja/hemat/${endpoint}/status?id=${id}`;
    const headers = new HttpHeaders({
      'Content-Type': 'application/json',
      'x-api-key': 'j2yaYvPSQcsEEmHh3NEobfiXyyXmmnHT'
    });
    return this.http.get<any>(url, { headers });
  }
}
